import 'cross-fetch/polyfill';
interface IProps {
    delay?: number;
}
interface IProgressPayload {
    readonly start: Date | undefined;
    readonly received: number | undefined;
    readonly size: number | undefined;
}
export declare class HttpClient {
    static getInstance(props?: IProps): HttpClient;
    private static instance;
    private delay;
    private isLoadingCallback;
    private isProgressCallback;
    private loadingResponses;
    private wasLoading;
    private constructor();
    onLoading(callback: (isLoading: boolean) => void): void;
    /**
     * Note: this only works if webstreams are supported
     */
    onProgress(callback: (progress: IProgressPayload) => unknown): void;
    fetch(input: RequestInfo, options?: RequestInit | undefined): Promise<Response>;
    private removeResponse;
    private handleLoadingStateUpdate;
}
export {};
